
$colors: (
    (#007bff, primary),
    (#17a2b8, info),
    (#28a745, success),
    (#ff9500, warning),
    (#dc3545, danger),
);

@mixin makeStyleFor($type, $icon) {
  .#{$type} {
    label {
      display: inline-block;
      vertical-align: middle;
      position: relative;

      span {
        font-family: "Roboto";
        font-weight: 500;
        font-size: 13px;
        margin-left: 5px;
        line-height: 17px;
      }

      &::before,
      &::after {
        display: inline-block;
        left: 0;
        float: left
      }

      &::after {
        position: absolute;
        width: 17px;
        height: 17px;
        top: 0;
        font-size: 7px;
        color: #555;
        line-height: 17px;
        text-align: center;
      }

      &::before {
        content: "";
        width: 17px;
        height: 17px;
        border: 1px solid #ccc;
        border-radius: 3px;
        background-color: #fff;

        -webkit-transition: border .15s ease-in-out, color .15s ease-in-out;
        -moz-transition: border .15s ease-in-out, color .15s ease-in-out;
        -ms-transition: border .15s ease-in-out, color .15s ease-in-out;
        -o-transition: border .15s ease-in-out, color .15s ease-in-out;
        transition: border .15s ease-in-out, color .15s ease-in-out
      }
    }
  }

  input[type="#{$type}"] {
    opacity: 0;
    z-index: 1;
    cursor: pointer;
    width: 0;
    height: 0;
    display: none;

    &:checked + label {
      &::before {
        outline: none;
      }

      &::after {
        font-family: "Font Awesome 5 Free";
        font-weight: 900;
        content: unquote("\"#{$icon}\"");
      }
    }

    &:indeterminate + label::after {
      display: block;
      content: "";
    }

    &:disabled {
      cursor: not-allowed;

      + label {
        opacity: .65;

        &::before {
          background-color: #eee;
          cursor: not-allowed;
        }
      }
    }
  }

  .#{$type}-inline {
    margin-top: 0;
  }

  @each $color in $colors {
    .#{$type}-#{nth($color, 2)} input[type="#{$type}"] {
      &:checked + label::after {
        color: #fff;
      }

      &:indeterminate + label::after {
        background-color: #fff !important;
      }

      &:checked + label::before {
        background-color: nth($color, 1);
        border-color: nth($color, 1);
      }
    }
  }

}

@include makeStyleFor(checkbox, \f00c);
@include makeStyleFor(radio, \f00c);

.checkbox.checkbox-circle label::before {
  border-radius: 50%;
}
